#property copyright "EquityHedgeGraph - by transcendreamer - origins from Xupypr"
// building two equity graphs, one vs another, to seek hedge opportunities visually
// each graph may represent a single instrument or a lot-adusted basket
// spreads and swaps are not counted
// Total = Side_A - Side_B

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1 clrRed
#property indicator_color2 clrDodgerBlue
#property indicator_color3 clrGreen
#property indicator_color4 clrWhite
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 1
#property indicator_width4 1
#property indicator_level1 0

extern datetime Time_Open    =D'2016.01.01 00:00';  //    
extern datetime Time_Close   =D'2016.12.31 00:00'; //    
extern bool     General_Line =false; //  . -     /
extern double   Default_Lot  =0.01;    //    ,        
//---  ,     buy   sell
//--- " "     
//---     ,    
//---     
extern string   Symbols_Side_A ="EURUSD-0.1 GBPUSD+0.1";
extern string   Symbols_Side_B ="";
extern bool     Show_Total     =true;  //   
extern bool     Show_Side_A    =false;   //     
extern bool     Show_Side_B    =false;  //     
extern string   start_prfx     ="", end_prfx="";
extern int MA_Period = 1; //  
extern int MA_Shift = 0; //  
extern ENUM_MA_METHOD MA_Method = MODE_SMMA; //  
input string tex_magic="MA"; //   
input double Grid_Size=0; //  , 0 =  

int      Total;
bool     First;
double   TotalEquity[],Equity_A[],Equity_B[];
string   ShortName, myEquityA, myEquityB, myOpenAll, myCloseAll;

int      OpenBar;      //   
int      CloseBar;     //   
int      Type[];       //  
string   Instrument[]; // 
double   Lots[];       //  
double   OpenPrice[];  //  
double   ma[];
int Window;
//+----------------------------------------------------------------------------+
//|  Custom indicator initialization function                                  |
//+----------------------------------------------------------------------------+
void OnInit()
{
 SetIndexBuffer(0,TotalEquity);
 SetIndexLabel(0,"Total");
 SetIndexStyle(0,DRAW_LINE);
 SetIndexBuffer(1,Equity_A);
 SetIndexLabel(1,"Side A");
 SetIndexStyle(1,DRAW_LINE);
 SetIndexBuffer(2,Equity_B);
 SetIndexLabel(2,"Side B");
 SetIndexStyle(2,DRAW_LINE);
 SetIndexBuffer(3,ma);
 SetIndexLabel(3,"MA");
 SetIndexStyle(3,DRAW_LINE);
 ShortName="Equity Hedge Graph";
 //if (Show_Total) ShortName=StringConcatenate(ShortName," Total");
 //if (Show_Side_A)   ShortName=StringConcatenate(ShortName," Side A");
 //if (Show_Side_B)  ShortName=StringConcatenate(ShortName," Side B");
 IndicatorShortName(ShortName);
 //Window=WindowFind(ShortName);
 Window=ChartWindowFind();
 myEquityA="EquityA_"+IntegerToString(Window);
 myEquityB="EquityB_"+IntegerToString(Window);
 myOpenAll="openall_"+IntegerToString(Window);
 myCloseAll="closeall_"+IntegerToString(Window);
 ObjectCreate(myEquityA,OBJ_LABEL,Window,0,0);
 ObjectSet(myEquityA,OBJPROP_XDISTANCE,5);
 ObjectSet(myEquityA,OBJPROP_YDISTANCE,15);
 ObjectSet(myEquityA,OBJPROP_CORNER,0);
 ObjectSetText(myEquityA,Symbols_Side_A,10,"Tahoma",indicator_color2);
 ObjectCreate(myEquityB,OBJ_LABEL,Window,0,0);
 ObjectSet(myEquityB,OBJPROP_XDISTANCE,5);
 ObjectSet(myEquityB,OBJPROP_YDISTANCE,30);
 ObjectSet(myEquityB,OBJPROP_CORNER,0);
 ObjectSetText(myEquityB,Symbols_Side_B,10,"Tahoma",indicator_color3);
 WindowRedraw();
 IndicatorDigits(2);
 First=true;
}
void DeInit() {
   if (ObjectFind(myEquityA) > -1) ObjectDelete(myEquityA);
   if (ObjectFind(myEquityB) > -1) ObjectDelete(myEquityB);
   if (ObjectFind(myOpenAll) > -1) ObjectDelete(myOpenAll);
   if (ObjectFind(myCloseAll) > -1) ObjectDelete(myCloseAll);
}
//+----------------------------------------------------------------------------+
//|  Custom indicator iteration function                                       |
//+----------------------------------------------------------------------------+
int OnCalculate( const int      rates_total,      //   
                 const int      prev_calculated,  //     
                 const datetime &time[],          // Time
                 const double   &open[],          // Open
                 const double   &high[],          // High
                 const double   &low[],           // Low
                 const double   &close[],         // Close
                 const long     &tick_volume[],   // Tick Volume
                 const long     &volume[],        // Real Volume
                 const int      &spread[]         // Spread
   )
{
 static string minfosymbols="";
 double A_profitloss,
        B_profitloss,
      /*spread,*/
        lotsize;
 int bar,
     i,
     j;
/*
 if (!IsConnected())
 {
  Print("     ");
  return(0);
 }
*/
 if (General_Line)
 {
  if (ObjectFind(myOpenAll)==-1) ObjectCreate(myOpenAll,OBJ_VLINE,Window,Time_Open,0);
  if (ObjectFind(myCloseAll)==-1) ObjectCreate(myCloseAll,OBJ_VLINE,Window,Time_Close,0);
  if (ObjectGet(myOpenAll,OBJPROP_TIME1)!=Time_Open || ObjectGet(myCloseAll,OBJPROP_TIME1)!=Time_Close)
  {
   First=true;
   Time_Open=ObjectGet(myOpenAll,OBJPROP_TIME1);
   Time_Close=ObjectGet(myCloseAll,OBJPROP_TIME1);
   ArrayInitialize(TotalEquity,EMPTY_VALUE);
   ArrayInitialize(Equity_A,EMPTY_VALUE);
   ArrayInitialize(Equity_B,EMPTY_VALUE);
  }
 }
 OpenBar=iBarShift(NULL,0,Time_Open);
 CloseBar=iBarShift(NULL,0,Time_Close,true);
 if (First)
 {
  First=false;
  Total=0;
  SetOrder(Symbols_Side_A,OP_BUY);
  SetOrder(Symbols_Side_B,OP_SELL);
  if (Total==0)
  {
   Alert("    !");
   return(0);
  }
 }
 else
 {
  if (Total==0)    return(0);
  if (CloseBar>=0) return(0);
  else
  {
   OpenBar=1;
   CloseBar=0;
  }
 }
 for (i=OpenBar;i>=CloseBar;i--)
 {
  A_profitloss=0.0;
  B_profitloss=0.0;
  for (j=0;j<Total;j++)
  {
   if (MarketInfo(f(Instrument[j]),MODE_POINT)==0)
   {
    if (StringFind(minfosymbols,Instrument[j])==-1)
    {
     Alert("     "+f(Instrument[j]));
     minfosymbols=StringConcatenate(minfosymbols," ",Instrument[j]);
    }
    continue;
   }
   bar=iBarShift(f(Instrument[j]),0,Time[i]);
   lotsize=LotSize(Instrument[j],Time[i]);
   if (Type[j]==OP_BUY) A_profitloss+=(iClose(f(Instrument[j]),0,bar)-OpenPrice[j])*Lots[j]*lotsize;
   else
   {
    //spread=MarketInfo(Instrument[j],MODE_POINT)*MarketInfo(Instrument[j],MODE_SPREAD);
    //B_profitloss+=(OpenPrice[j]-iClose(Instrument[j],0,bar)-spread)*Lots[j]*lotsize;
    B_profitloss+=(iClose(f(Instrument[j]),0,bar)-OpenPrice[j])*Lots[j]*lotsize;
   }
  }
  if (Show_Total) TotalEquity[i]=NormalizeDouble(A_profitloss-B_profitloss,2);
  if (Show_Side_A) Equity_A[i]=NormalizeDouble(A_profitloss,2);
  if (Show_Side_B) Equity_B[i]=NormalizeDouble(B_profitloss,2);
 }
   
   for (i=OpenBar;i>=CloseBar;i--){ 
      ma[i] = iMAOnArray(TotalEquity,0,MA_Period,MA_Shift,MA_Method,i);
   } 
  GlobalVariableSet (tex_magic, TotalEquity[0]-ma[0]);
  if(Grid_Size>0) DisplayGrid();
  return(0);
}
//+----------------------------------------------------------------------------+
//|                                                 |
//+----------------------------------------------------------------------------+
double LotSize(string symbol, datetime tbar)
{
 double size;
 string BQ,currency=AccountCurrency();
 switch ((int)MarketInfo(f(symbol),MODE_PROFITCALCMODE))
 {
  case 0:
  {
   int sbar=iBarShift(f(symbol),0,tbar);
   size=MarketInfo(f(symbol),MODE_LOTSIZE);
   if (StringSubstr(symbol,3,3)=="USD") break;
   if (StringSubstr(symbol,0,3)=="USD") size=size/iClose(f(symbol),0,sbar);
   else
   {
    BQ=StringSubstr(symbol,0,3)+"USD";
    if (iClose(f(BQ),0,0)==0) BQ="USD"+StringSubstr(symbol,0,3);
    if (iClose(f(BQ),0,0)==0) break;
    int BQbar=iBarShift(f(BQ),0,tbar);
    if (StringSubstr(BQ,0,3)=="USD") size=size/iClose(f(BQ),0,BQbar)/iClose(f(symbol),0,sbar);
    else size=size*iClose(f(BQ),0,BQbar)/iClose(f(symbol),0,sbar);
   }
  } break;
  case 1: size=MarketInfo(f(symbol),MODE_LOTSIZE); break;
  case 2: size=MarketInfo(f(symbol),MODE_TICKVALUE)/MarketInfo(f(symbol),MODE_TICKSIZE);
 }
 if (currency!="USD")
 {
  BQ=currency+"USD";
  if (iClose(f(BQ),0,0)==0)
  {
   BQ="USD"+currency;
   size*=iClose(f(BQ),0,iBarShift(f(BQ),0,tbar));
  }
  else size/=iClose(f(BQ),0,iBarShift(f(BQ),0,tbar));
 }
 return(size);
}
//+----------------------------------------------------------------------------+
//|                                                   |
//+----------------------------------------------------------------------------+
void SetOrder(string name, int cmd)
{
 int length,pos,end;
 
 length=StringLen(name);
 pos=0;
 while (pos<length)
 {
  Total++;
  ArrayResize(Type,Total);
  ArrayResize(Instrument,Total);
  ArrayResize(Lots,Total);
  ArrayResize(OpenPrice,Total);
  Type[Total-1]=cmd;
  Instrument[Total-1]=StringSubstr(name,pos,6);
  pos+=6;
  if (StringGetChar(name,pos)==32 || (length-1)<pos) Lots[Total-1]=Default_Lot;
  else
  {
   end=0;
   while(StringGetChar(name,pos+end)!=32)
   {
    if ((length-1)<pos+end) break;
    end++;
   }
   Lots[Total-1]=StrToDouble(StringSubstr(name,pos,pos+end));
   pos+=end;
  }
  pos++;
  OpenPrice[Total-1]=iOpen(f(Instrument[Total-1]),0,iBarShift(f(Instrument[Total-1]),0,Time_Open));
  //if (cmd==OP_BUY) OpenPrice[Total-1]+=MarketInfo(Instrument[Total-1],MODE_POINT)*MarketInfo(Instrument[Total-1],MODE_SPREAD);
 }
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

string f(string tex)
{
return(start_prfx+tex+end_prfx);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void DisplayGrid()
{

if(Grid_Size==0) return;
double max=-1.7976931348623158e+308, min=1.7976931348623158e+308;
int open_bar=Bars-1; 
int close_bar=0;

for(int j=open_bar; j>=close_bar; j--)
   {
   if(TotalEquity[j]==EMPTY_VALUE) continue;
   if(TotalEquity[j]>max) max=TotalEquity[j];
   if(TotalEquity[j]<min) min=TotalEquity[j];
   }

double y=0;
string name;
while(y<max)
   {
   y+=Grid_Size;
   name="Grid-level-"+(string)Window+":"+DoubleToString(y,2);
   PlaceHorizontal(name,y,Silver,STYLE_DOT,true,false);
   }

y=0; 
while(y>min)
   {
   y-=Grid_Size;
   name="Grid-level-"+(string)Window+":"+DoubleToString(y,2);
   PlaceHorizontal(name,y,Silver,STYLE_DOT,true,false);
   }

}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

void PlaceHorizontal(string name, double price, int colour, int style, bool back, bool select)
{
ObjectCreate(0,name,OBJ_HLINE,Window,0,price);
ObjectSetInteger(0,name,OBJPROP_COLOR,colour);
ObjectSetInteger(0,name,OBJPROP_STYLE,style);
ObjectSetInteger(0,name,OBJPROP_BACK,back);
ObjectSetInteger(0,name,OBJPROP_SELECTABLE,select);
}
